Attribute VB_Name = "modDeclares"
Option Explicit

Public Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean
Public Declare Function GetTickCount Lib "kernel32.dll" () As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub ExitProcess Lib "kernel32" (ByVal uExitCode As Long)
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public ErrorCount As Long


Public nID As NOTIFYICONDATA
Public Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uId As Long
    uFlags As Long
    uCallBackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Public Const NIM_ADD = &H0
Public Const NIM_MODIFY = &H1
Public Const NIM_DELETE = &H2
Public Const NIF_MESSAGE = &H1
Public Const NIF_ICON = &H2
Public Const NIF_TIP = &H4
Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDOWN = &H201 'Button down
Public Const WM_LBUTTONUP = &H202 'Button up
Public Const WM_LBUTTONDBLCLK = &H203 'Double-click
Public Const WM_RBUTTONDOWN = &H204 'Button down
Public Const WM_RBUTTONUP = &H205 'Button up
Public Const WM_RBUTTONDBLCLK = &H206 'Double-click
Public Const WM_COMMAND = &H111

Public Function RemoveAsterisk(ByVal Username As String) As String
    If InStr(Username, "*") > 0 Then
        RemoveAsterisk = Mid$(Username, InStr(Username, "*") + 1)
    Else
        RemoveAsterisk = Username
    End If
End Function

Public Function GetBinaries(ByVal Client As String) As String()
    Dim Files(2) As String
    Select Case UCase$(Client)
        Case "STAR", "SEXP"
            Files(0) = App.Path & "\Binaries\STAR\StarCraft.exe"
            Files(1) = App.Path & "\Binaries\STAR\Storm.dll"
            Files(2) = App.Path & "\Binaries\STAR\Battle.snp"
        Case "W2BN"
            Files(0) = App.Path & "\Binaries\W2BN\WarCraft II BNE.exe"
            Files(1) = App.Path & "\Binaries\W2BN\Storm.dll"
            Files(2) = App.Path & "\Binaries\W2BN\Battle.snp"
        Case "D2DV"
            Files(0) = App.Path & "\Binaries\D2DV\Game.exe"
            Files(1) = App.Path & "\Binaries\D2DV\Bnclient.dll"
            Files(2) = App.Path & "\Binaries\D2DV\D2client.dll"
        Case "D2XP"
            Files(0) = App.Path & "\Binaries\D2XP\Game.exe"
            Files(1) = App.Path & "\Binaries\D2XP\Bnclient.dll"
            Files(2) = App.Path & "\Binaries\D2XP\D2client.dll"
        Case "WAR3", "W3XP"
            Files(0) = App.Path & "\Binaries\WAR3\War3.exe"
            Files(1) = App.Path & "\Binaries\WAR3\Storm.dll"
            Files(2) = App.Path & "\Binaries\WAR3\Game.dll"
    End Select
    GetBinaries = Files
End Function

Public Function DebugOutput(ByVal sIn As String) As String
    Dim x1 As Long, y1 As Long
    Dim iLen As Long, iPos As Long
    Dim sB As String, ST As String
    Dim sOut As String
    Dim Offset As Long, sOffset As String
    
    'build random string to display
'    y1 = 256
'    sIn = String(y1, 0)
'    For x1 = 1 To 256
'        Mid(sIn, x1, 1) = Chr(x1 - 1)
'        'Mid(sIn, x1, 1) = Chr(255 * Rnd())
'    Next x1
    
    iLen = Len(sIn)
    If iLen = 0 Then Exit Function
    sOut = ""
    Offset = 0
    For x1 = 0 To ((iLen - 1) \ 16)
        sOffset = Right$("0000" & Hex(Offset), 4)
        sB = String(48, " ")
        ST = "................"
        For y1 = 1 To 16
        iPos = 16 * x1 + y1
        If iPos > iLen Then Exit For
        Mid(sB, 3 * (y1 - 1) + 1, 2) = Right("00" & Hex(Asc(Mid(sIn, iPos, 1))), 2) & " "
        Select Case Asc(Mid(sIn, iPos, 1))
        Case 0, 9, 10, 13
        Case Else
            Mid(ST, y1, 1) = Mid(sIn, iPos, 1)
        End Select
        Next y1
        If Len(sOut) > 0 Then sOut = sOut & vbCrLf
        sOut = sOut & sOffset & ":  "
        sOut = sOut & sB & "  " & ST
        Offset = Offset + 16
    Next x1
    DebugOutput = sOut
End Function

